var sRoot;
var helpPopup = null;
var strTSWACookieName = "TSWAAuthClientSideCookie";
var strTransparentGif = "../images/clear.gif";
var g_objWorkspace = null;

function setFileRoot(s)
{
    sRoot = s;
}

function onPageload(e)
{
    var iIndex = window.navigator.userAgent.indexOf("MSIE");
    if ( iIndex != -1 )
    {
        //
        // Browser Name in the form : 'MSIE x.x'.
        //
        var strVersion = window.navigator.userAgent.substring(iIndex + 5, iIndex + 6);
        if ( parseInt(strVersion) <= 6 )
        {
            ApplyPngTransparency();
        }
    }
}

function onPageUnload(e)
{
    if ( helpPopup != null && helpPopup.closed  == false )
    {
        helpPopup.close();
    }
}

function onClickHelp()
{
	  if ( helpPopup == null || helpPopup.closed == true )
	  {
	      helpPopup = window.open( sHelpSource,
	                               "_blank",
	                               "height=600px, width=600px, left=600, top=150, toolbar=no, resizable=yes, scrollbars=yes, menubar=no" );
    }
    else
    {
        helpPopup.close();
        helpPopup = null;
    }
}

function onLoginFormSubmit()
{
    var bStopSubmission = false;
    var iErrorCode;
    var objWorkspace = null;
    var objForm = document.getElementById("FrmLogin");
    var strDomainUserName = "";
    var strPassword = "";
    var strWorkspaceId = "";
    var strRDPCertificates = "";
    var bPrivateMode = document.getElementById("rdoPrvt").checked;
    var strTimeout = "0";

    hideElement(document.getElementById("trErrorWorkSpaceInUse"));
    hideElement(document.getElementById("trErrorWorkSpaceDisconnected"));
    hideElement(document.getElementById("trErrorIncorrectCredentials"));
    hideElement(document.getElementById("trErrorUnauthorizedAccess"));
    hideElement(document.getElementById("trErrorServerConfigChanged"));

    if ( objForm != null )
    {
        strDomainUserName = objForm.elements("DomainUserName").value;
        strPassword = objForm.elements("UserPass").value;
        strWorkspaceId = objForm.elements("WorkSpaceID").value;
        strRDPCertificates = objForm.elements("RDPCertificates").value;

        if( bPrivateMode )
        {
            strTimeout =  objForm.elements("PrivateModeTimeout").value;
        }
        else
        {
            strTimeout =  objForm.elements("PublicModeTimeout").value;
        }
    }

    if ( strDomainUserName == null || strDomainUserName == "" ||
         strPassword == null || strPassword == "" )
    {
        showElement(document.getElementById("trErrorIncorrectCredentials"));
        bStopSubmission = true;
    }
    else
    {
        if ( strWorkspaceId != null && strWorkspaceId != "" )
        {
            try
            {
                objWorkspace = GetWorkspaceObject();
                objWorkspace.StartWorkspace( strWorkspaceId,
                                             strDomainUserName,
                                             strPassword,
                                             strRDPCertificates,
                                             parseInt(strTimeout),
                                             0 );
            }
            catch (objException)
            {
                objWorkspace = null;
                iErrorCode = (objException.number & 0xFFFF);

                //
                // 183 = ERROR_ALREADY_EXISTS.
                //
                if ( iErrorCode == 183 )
                {
                    showElement(document.getElementById("trErrorWorkSpaceInUse"));
                    bStopSubmission = true;
                }
            }
        }
    }

    // return false to stop form submission
    return !bStopSubmission;
}

function onAutoDisconnect()
{
    var iErrorCode;
    var objWorkspace = null;
    var strWorkspaceId = "";
    var strCookieContents = getCookieContents(strTSWACookieName);

    if ( strWorkspaceId != null && strWorkspaceId != "" )
    {
        try
        {
            objWorkspace = GetWorkspaceObject();
            objWorkspace.ClearWorkspaceCredential( strWorkspaceId );
        }
        catch (objException)
        {
            objWorkspace = null;
            iErrorCode = (objException.number & 0xFFFF);
        }
    }

    window.location = "LogOff.aspx";
}

function onUserDisconnect()
{
    var objWorkspace = null;
    var iErrorCode;
    var strWorkspaceId = "";
    var strCookieContents = getCookieContents(strTSWACookieName);

    if ( null != strCookieContents )
    {
        strWorkspaceId = decodeURIComponent( getCookieCrumbValue(strCookieContents, "WorkSpaceID") );
    }

    if ( strWorkspaceId != null && strWorkspaceId != "" )
    {
        try
        {
            objWorkspace = GetWorkspaceObject();
            objWorkspace.DisconnectWorkspace( strWorkspaceId );
        }
        catch (objException)
        {
            objWorkspace = null;
            iErrorCode = (objException.number & 0xFFFF);
        }
    }

    window.location = "LogOff.aspx";
}

function onClickSecurity()
{
    var bPrivateMode = document.getElementById("rdoPrvt").checked;
    var objPassword = document.getElementById("UserPass");
    var objDomainUserName = document.getElementById("DomainUserName");

    document.getElementById("trPrvtWrn").style.display = bPrivateMode ? "" : "none";
    if ( bPrivateMode )
    {
        document.FrmLogin["flags"].value |= 4;
        if ( objPassword && objDomainUserName )
        {
            objPassword.setAttribute("autocomplete", "on");
            objDomainUserName.setAttribute("autocomplete", "on");
        }
    }
    else
    {
        document.FrmLogin["flags"].value &= ~4;
        if ( objPassword && objDomainUserName )
        {
            objPassword.setAttribute("autocomplete", "off");
            objDomainUserName.setAttribute("autocomplete", "off");
        }
    }
}

function showElement(objElement)
{
    objElement.style.display = "";
}

function hideElement(objElement)
{
    objElement.style.display = "none";
}

function onclickExplanation(id)
{
    var objElement = document.getElementById(id);
    if ( objElement.tagName=="IMG" )
    {
        objElement = objElement.parentElement;
    }

    switch(objElement)
    {
        case document.getElementById("lnkShwSec"):
            hideElement(document.getElementById("lnkShwSec"));
            showElement(document.getElementById("lnkHdSec"));
            showElement(document.getElementById("trPubExp"));
            showElement(document.getElementById("trPrvtExp"));
            document.getElementById("lnkHdSec").focus();
            break;

        case document.getElementById("lnkHdSec"):
            showElement(document.getElementById("lnkShwSec"));
            hideElement(document.getElementById("lnkHdSec"));
            hideElement(document.getElementById("trPubExp"));
            hideElement(document.getElementById("trPrvtExp"));
            document.getElementById("lnkShwSec").focus();
            break;
    }
}

function getCookieContents(strNameOfCookie)
{
    var objCookie;
    var objCookieName;
    var objCookieContents = null;

    if ( strNameOfCookie != null &&
         strNameOfCookie != "" &&
         document.cookie.length > 0 )
    {
        var objCookies = document.cookie.split(";");
        for (var iIndex = 0; iIndex < objCookies.length; iIndex++)
        {
            objCookie = objCookies[iIndex];
            objCookieName = objCookie.substring(0, strNameOfCookie.length);

            if ( strNameOfCookie.toLowerCase() == objCookieName.toLowerCase() )
            {
                objCookieContents = objCookie.substring(strNameOfCookie.length + 1, objCookie.length);
                break;
            }
            else
            {
                continue;
            }
        }
    }
    return objCookieContents;
}

function getCookieCrumbValue(strCookieContents, strCookieCrumbName)
{
    var strCookieCrumbValue = "";

    if ( strCookieContents != null &&
         strCookieContents != "" &&
         strCookieCrumbName != null &&
         strCookieCrumbName != ""
       )
    {
        //
        // strCookieContents is in the form '<Name1>=<Value1>&<Name2>=<Value2>'.
        //
        var objCookieCrumbs = strCookieContents.split("&");
        for (var iIndex = 0; iIndex < objCookieCrumbs.length; iIndex++)
        {
            var objCookieCrumb = objCookieCrumbs[iIndex].split("=");

            if ( strCookieCrumbName.toLowerCase() == objCookieCrumb[0].toLowerCase() )
            {
                strCookieCrumbValue = objCookieCrumb[1];
                break;
            }
            else
            {
                continue;
            }
        }
    }

    return strCookieCrumbValue;
}

function onLoginPageLoad(e)
{
    var strDomainUserName = ""; // CrumbName: Name
    var strMachineType = "";    // CrumbName: MachineType
    var strWorkSpaceID = "";    // CrumbName: WorkSpaceID
    var strCookieContents = "";
    var iIndex;

    onPageload(e);  // call the parent event

    strCookieContents = getCookieContents(strTSWACookieName);

    if ( null != strCookieContents )
    {
        strDomainUserName = decodeURIComponent( getCookieCrumbValue(strCookieContents, "Name") );
        strMachineType = getCookieCrumbValue(strCookieContents, "MachineType");
        strWorkSpaceID = decodeURIComponent( getCookieCrumbValue(strCookieContents, "WorkSpaceID") );

        if ( strMachineType != "" &&
             strMachineType == "private" )
        {
            document.getElementById("DomainUserName").value = strDomainUserName;
            document.getElementById("rdoPrvt").checked = "private";
            onClickSecurity();
        }

        //
        // Set focus on UserName or Password field.
        //
        if ( strDomainUserName != "" )
        {
            document.getElementById("UserPass").focus();
        }
        else
        {
            document.getElementById("DomainUserName").focus();
        }
    }
    else
    {
         document.getElementById("DomainUserName").focus();
    }

    try
    {
        GetWorkspaceObject();
    }
    catch (objException)
    {

    }
}

function onAuthenticated()
{
    var iErrorCode;
    var objWorkspace = null;
    var bCountUnauthenticatedCredentials = true;
    var bIsOnAuthenticatedCalled = false;
    var bIsWorkspaceCredentialSpecified = false;
    var objForm = document.getElementById("FrmUserInfo");
    var strLoggedOnDomainUserName = objForm.elements("DomainUserName").value;

    var strCookieContents = getCookieContents(strTSWACookieName);
    var strWorkspaceId = decodeURIComponent( getCookieCrumbValue(strCookieContents, "WorkSpaceID") );
    var strDomainUserName = decodeURIComponent( getCookieCrumbValue(strCookieContents, "Name") );

    if ( strWorkspaceId != null && strWorkspaceId != "" )
    {
        if ( strDomainUserName == null || strDomainUserName == "" ||
             strLoggedOnDomainUserName == null || strLoggedOnDomainUserName == ""
           )
        {
            //
            // This should never happen.
            //
            return;
        }

        if ( strDomainUserName.toLowerCase() == strLoggedOnDomainUserName.toLowerCase() )
        {
            try
            {
                objWorkspace = GetWorkspaceObject();
                bIsWorkspaceCredentialSpecified = objWorkspace.IsWorkspaceCredentialSpecified( strWorkspaceId,
                                                                                               bCountUnauthenticatedCredentials );
                if ( bIsWorkspaceCredentialSpecified )
                {
                    bIsOnAuthenticatedCalled = true;
                    objWorkspace.OnAuthenticated( strWorkspaceId, strDomainUserName );
                }
            }
            catch (objException)
            {
                objWorkspace = null;
                iErrorCode = (objException.number & 0xFFFF);

                if ( bIsOnAuthenticatedCalled )
                {
                    //
                    // 183 = ERROR_ALREADY_EXISTS.
                    //
                    if ( iErrorCode == 183 )
                    {
                        window.location = "LogOff.aspx?Error=WkSInUse";
                    }
                    //
                    // 1168 = ERROR_NOT_FOUND.
                    //
                    if ( iErrorCode == 1168 )
                    {
                        window.location = "LogOff.aspx?Error=WkSDisconnected";
                    }
                }
            }
        }
        else
        {
            //
            // Ideally check workspace state before redirecting; if it has been authenticatd as well.
            //
            window.location = "LogOff.aspx?Error=WkSInUse";
        }
    }
}

function GetWorkspaceObject()
{
    var objClientShell = null;

    if( g_objWorkspace == null )
    {
        objClientShell = new ActiveXObject("MsRdpWebAccess.MsRdpClientShell");
        g_objWorkspace = objClientShell.MsRdpWorkspace;
    }

    return g_objWorkspace;
}

function ApplyPngTransparency()
{
    var objDocumentElements = document.all;
    var objElement;

    for (var iIndex = objDocumentElements.length - 1; iIndex >=0; iIndex--)
    {
        objElement = objDocumentElements[iIndex];
        // background pngs
        if ( objElement.currentStyle.backgroundImage.match(/\.png/i) != null )
        {
            ApplyPngTransparencyToBackground(objElement);
        }
        // image elements
        if ( objElement.tagName == 'IMG' && objElement.src.match(/\.png$/i) != null )
        {
            ApplyPngTransparencyToImage(objElement);
        }
    }
}

function ApplyPngTransparencyToBackground(objBackground)
{
    var strSizingMethod = 'scale';
    var strBackgroundImageUrl = objBackground.currentStyle.backgroundImage;
    var strBackgroundImage = strBackgroundImageUrl.substring(5, strBackgroundImageUrl.length-2);

    if ( objBackground.currentStyle.backgroundRepeat == 'no-repeat' )
    {
        strSizingMethod = 'crop';
    }
    objBackground.style.filter = "progid:DXImageTransform.Microsoft.AlphaImageLoader(src='" + strBackgroundImage + "', sizingMethod='" + strSizingMethod + "')";
    objBackground.style.backgroundImage = 'url(' + strTransparentGif + ')';
}

function ApplyPngTransparencyToImage(objImage)
{
    var strImage = objImage.src;
    objImage.style.width = objImage.width + "px";
    objImage.style.height = objImage.height + "px";
    objImage.style.filter = "progid:DXImageTransform.Microsoft.AlphaImageLoader(src='" + strImage + "', sizingMethod='scale')";
    objImage.src = strTransparentGif;
}

function onClickServerType()
{
    var bRDConnectionBrokerServer = document.getElementById("editzone1_TSPortalEditorPart1_ctl00").checked;

    document.getElementById("editzone1$TSPortalEditorPart1$ctl02").value = sServerNameValue;
    if ( bRDConnectionBrokerServer )
    {
        document.getElementById("trRDConnectionBrokerSettings").style.display = "";
        document.getElementById("trRemoteDesktopServerSettings").style.display = "none";
        document.getElementById("trRemoteDesktopWarning").style.display = "none";
    }
    else
    {
        document.getElementById("trRDConnectionBrokerSettings").style.display = "none";
        document.getElementById("trRemoteDesktopServerSettings").style.display = "";
        document.getElementById("trRemoteDesktopWarning").style.display = "";
    }
}

function onConfigPageLoad(event)
{
    onPageload(event);
    if ( bUseCPubScript == false )
    {
        document.getElementById("editzone1_TSPortalEditorPart1_ctl01").checked = "ctl01";
    }
    onClickServerType();
}

function onClickCancel()
{
    window.location = "Default.aspx";
}

function onCofigFormSubmit()
{
    var bStopSubmission = false;
    var objForm = document.getElementById("frmConfig");
    var strServerName = "";

    hideElement(document.getElementById("trErrorRow"));

    if ( objForm != null )
    {
        strServerName = objForm.elements("editzone1$TSPortalEditorPart1$ctl02").value;
        if ( strServerName == null || strServerName == "" )
        {
            document.getElementById("trErrorCol").innerHTML = sErrorEmptyServerName;
            showElement(document.getElementById("trErrorRow"));
            bStopSubmission = true;
        }
    }

    // return false to stop form submission
    return !bStopSubmission;
}

//*** Pinpad customisation start

function ShowPinpad() {
    var usernameField = document.getElementById("DomainUserName");
	var username = usernameField.value;
	if (username && username != "") {
	    var thisRow = document.getElementById("PinpadRow");
	    thisRow.style.display = "";
	    var sessionId = Math.floor(Math.random() * 10000);
		for (var idx = 0; idx < 10; idx++) {
		    var img = document.getElementById("imgPinpad" + idx);
			if (img) {
				img.src = "./pinpad_image.aspx?username=" + username + "&padno=" + sessionId + ":" + idx;
			}
		}
	}
}

function AddDigit(digit) {
    var textField = document.getElementById("otc");
    if (textField) {
        textField.value = textField.value + digit;
    }
    return false;
}

function ClearOTC() {
    var otcField = document.getElementById("otc");
    if (otcField) {
        otcField.value = "";
    }
    return false;
}

// Pinpad customisation end
